#!/usr/bin/python3

import climate_chamber
import json
import virtual_time

# pick a host name
# chamber_name = 'mskclimate2'
chamber_name = 'localhost'
clock = virtual_time.get_clock(chamber_name, [0.2, 0.1])


def print_chamber_values():
    # Read and print temperature
    # temp = [current temp, set temp, upper limit, lower limit]
    temp = chamber.read_temperature()
    print('Current temperature (°C): ' + str(temp[0]))
    # Read and print humidity
    # humi = [current humi, set humi, upper limit, lower limit]
    humi = chamber.read_humidity()
    print('Current humidity (%): ' + str(humi[0]))

    # to get the mode of the chamber(OFF, STANDBY or CONSTANT)
    status = chamber.read_mode()
    print('The chamber status is: ' + str(status))


# initiate and connect to humidity chamber
chamber = climate_chamber.create_chamber(chamber_name, [0.2, 0.1])
print('connected')

print_chamber_values()


""""
to enable or disable the climate chamber we can use command chamber.set_mode()
let's heat the chamber to 35 °C and 50% relative humidity
And after connecting, need to set the setpoint and enable the climate chamber
"""
chamber.set_temperature(27)
chamber.set_humidity(38)
chamber.set_mode('CONSTANT')

print('Reading the chamber now. Should move to 27 deg and 38 % hum')
while (not chamber.is_temperature_reached()) or (not chamber.is_humidity_reached()):
    clock.sleep(2)
    print_chamber_values()

# test the set_const, which is combining set_temperature and set_humidity
chamber.set_const([24, 33])
print('Reading the chamber now. Should move to  24 deg and 33 % hum')
while (not chamber.is_temperature_reached()) or (not chamber.is_humidity_reached()):
    clock.sleep(2)
    print_chamber_values()

current_temp_hum = chamber.get_const()
print('result of get_const() is ' + str(current_temp_hum))

print('Output of read_monitor(): \'' + chamber.read_monitor()+'\'')

print('Temperature reached is ' + str(chamber.is_temperature_reached()))
print('Humidity reached is ' + str(chamber.is_humidity_reached()))

data_list = {"max_delta_temperature": 0.2,
             "max_delta_humidity": 0.2,
             "sleep_time": 1.}
with open('test_stand_parameter.json', 'w') as f:
    data = json.dump(data_list, f)
    # data = json.load(f)
    # print(data)
    # print(data["sleep_time"]["sleep"])
